{********************************************
; File: QDAux.p
;
;
; Copyright Apple Computer, Inc. 1986-93
; All Rights Reserved
;
********************************************}

UNIT QDAUX;
INTERFACE
USES TYPES,QUICKDRAW;
CONST


{
    PicInfo - The following picture
    opcodes are for reference only!!
}

frameVerb = $00;
picNop = $00;
drawCharVerb = $00;
paintVerb = $01;
picClipRgn = $01;
drawTextVerb  = $01;
eraseVerb = $02;
picBkPat = $02;
drawCStrVerb = $02;
invertVerb = $03;
picTxFont = $03;
fillVerb = $04;
picTxFace = $04;
picTxMode = $05;
picSpExtra = $06;
picPnSize = $07;
picPnMode = $08;
picPnPat = $09;
picThePat = $0A;
picFillPat = $0A;  { Please use picThePat }
picOvSize = $0B;
picOrigin = $0C;
picTxSize = $0D;
picFGColor = $0E;
picBGColor = $0F;
picTxRatio = $10;
picVersion = $11;
picChExtra = $12;
picPnMask = $13;
picArcRot = $14;
picFontFlags = $15;
lineNoun = $20;
picLine = $20;
picLineFrom = $21;
picShortL = $22;
picShortLine = $22;
picShortLFrom = $23;
picLongText = $28;
picDHText = $29;
picDVText = $2A;
picDVDHText = $2B;
rectNoun = $30;
rRectNoun = $40;
ovalNoun = $50;
arcNoun = $60;
polyNoun = $70;
rgnNoun = $80;
mapNoun = $90;
picBitsRect = $90;
picBitsRgn = $91;
picPBitsRect = $98;
picPBitsRgn = $99;
picShortComment = $A0;
picLongComment = $A1;
picEnd = $FF;

{ SeedFill/CalcMask Masks }
resMode640PMask = $00;
resMode640DMask = $01;
resMode320Mask = $02;
destModeCopyMask = $0000;
destModeLeaveMask = $1000;
destModeOnesMask = $2000;
destModeClrToZeros = $2000;
destModeZerosMask = $3000;
destModeClrToOnes = $3000;

{ Error Codes }
badRectSize = $1211;
destModeError = $1212;
badPictureOpcode = $121F;
badGetSysIconInput = $1230;

{ GetSysIcon constants }
fUseOpenFolders = $0004;
getFileIcon = $0000;
getDeviceIcon = $0001;
getMiscIcon = $0002;
desktopSysIcon = $0000;
padlockSysIcon = $0001;
upArrowSysIcon = $0002;
downArrowSysIcon = $0003;
boxDownArrowSysIcon = $0004;

{ WhooshRect constants }
whooshOut = $80000000;
whooshIn = 0;
fLocalCoordinates = $40000000;
fSilent = $20000000;

{ Other Constants }
fTextJust = $0008;

{ DrawStringWidth flag values }
dswNoCondense = $8000;
dswCondense = $0000;
dswNoTruncate = $0000;
dswTruncLeft = $2000;
dswTruncCenter = $4000;
dswTruncRight = $6000;
dswPString = $0000;
dswCString = $0004;
dswWString = $0008;
dswStrIsPtr = $0000;
dswStrIsHandle = $0001;
dswStrIsResource = $0002;

{ ColorTable flag values }
ctUse640Colors = $8000;
ctNoCtlNewRes = $4000;
ctIncludeMenuBar = $2000;

TYPE
QDIconRecordHndl = ^QDIconRecordPtr;
QDIconRecordPtr = ^QDIconRecord;
QDIconRecord = RECORD
    iconType : Integer;
    iconSize : Integer;
    iconHeight : Integer;
    iconWidth : Integer;
    iconImage : PACKED ARRAY[1..1] OF Byte;
    iconMask : PACKED ARRAY[1..1] OF Byte;
END;
PicHndl = ^PicPtr;
PicPtr = ^Picture;
Picture = RECORD
    picSCB : Integer;
    picFrame : Rect;
    pVersion : Integer; { Followed by picture opcodes  }
END;
LeakTablePtr = ^LeakTable;
LeakTable = RECORD
    leakCount : Integer;
    leakColors : ARRAY[1..16] OF Integer;
END;
PROCEDURE CalcMask ( srcLocInfoPtr:LocInfo; srcRect:Rect; dstLocInfoPtr:LocInfo; dstRect:Rect; resMode:Integer; aPatternPtr:PatternPtr; leakTblPtr:LeakTable);
PROCEDURE ClosePicture;
PROCEDURE CopyPixels ( srcLocPtr:LocInfo; destLocPtr:LocInfo; srcRect:Rect; destRect:Rect; xferMode:Integer; makeRgn:RegionHndl);
PROCEDURE DrawIcon ( iconPtr:QDIconRecord; displayMode:Integer; xPos:Integer; yPos:Integer);
PROCEDURE DrawPicture ( picHandle:PicHndl; destRect:Rect);
PROCEDURE KillPicture ( pichandle:PicHndl);
FUNCTION OpenPicture ( picFrame:Rect) : PicHndl ;
PROCEDURE PicComment ( kind:Integer; dataSize:Integer; dataHandle:Handle);
PROCEDURE QDAuxBootInit;
PROCEDURE QDAuxReset;
PROCEDURE QDAuxShutDown;
PROCEDURE QDAuxStartUp;
FUNCTION QDAuxStatus  : Boolean ;
FUNCTION QDAuxVersion  : Integer ;
PROCEDURE SeedFill ( srcLocInfoPtr:LocInfo; srcRect:Rect; dstLocInfoPtr:LocInfo; dstRect:Rect; seedH:Integer; seedV:Integer; resMode:Integer; aPatternPtr:PatternPtr; leakTblPtr:LeakTable);
PROCEDURE SpecialRect ( rectPtr:Rect; frameColor:Integer; fillColor:Integer);
PROCEDURE WaitCursor;

FUNCTION GetSysIcon(flags, value:integer; auxValue:longint): QDIconRecordPtr;
FUNCTION PixelMap2Rgn(loc:LocInfoPtr; bitsPerPixel, colorsToInclude:integer): RegionHndl;
PROCEDURE IBeamCursor;
PROCEDURE WhooshRect(flags:longint; smallRect, bigRect:Rect);

PROCEDURE DrawStringWidth (flags:integer; stringRef:Ref; width:integer);
  INLINE $A2,$1512,$22,$E10000,$8F,'_toolErr';
FUNCTION UseColorTable (tableNum:integer; table:ColorTablePtr; flags:integer): Handle;
  INLINE $A2,$1612,$22,$E10000,$8F,'_toolErr';
PROCEDURE RestoreColorTable (colorInfoHandle:Handle; flags:integer);
  INLINE $A2,$1712,$22,$E10000,$8F,'_toolErr';

IMPLEMENTATION
END.
